Package org.jboss.resteasy.plugins.providers.multipart

## Class MimeMultipartProvider

- java.lang.Object
- - org.jboss.resteasy.plugins.providers.AbstractEntityProvider<javax.mail.internet.MimeMultipart>
  - - org.jboss.resteasy.plugins.providers.multipart.MimeMultipartProvider

- All Implemented Interfaces:
    `javax.ws.rs.ext.MessageBodyReader<javax.mail.internet.MimeMultipart>`, `javax.ws.rs.ext.MessageBodyWriter<javax.mail.internet.MimeMultipart>`, `AsyncMessageBodyWriter<javax.mail.internet.MimeMultipart>`

      @Provider
      @Produces("multipart/mixed")
      @Consumes({"multipart/mixed","multipart/form-data"})
      public class MimeMultipartProvider
      extends AbstractEntityProvider<javax.mail.internet.MimeMultipart>

  A provider to handle multipart representations. This implementation will be invoked when a method parameter takes a `MimeMultipart` as a method parameter or a return value and the @Consumes value is either multipart/mixed or multipart/form-data.

  `@POST @Consumes("multipart/form-data") public void postData(MimeMultipart multipart) { ...`

  When the `MimeMultipart` is passed to the method body, it is up to the developer to extract the various parts.

  Author:
    Ryan J. McDonough

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MimeMultipartProvider()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `CompletionStage<Void>` | `asyncWriteTo​(javax.mail.internet.MimeMultipart mimeMultipart, Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders, AsyncOutputStream entityStream)` | Write a type to an HTTP message using async IO.
    `boolean` | `isReadable​(Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` | Ascertain if the MessageBodyReader can produce an instance of a particular type.
    `boolean` | `isWriteable​(Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType)` | Ascertain if the MessageBodyWriter supports a particular type.
    `static DataSource` | `readDataSource​(InputStream in, javax.ws.rs.core.MediaType mediaType)` |
    `javax.mail.internet.MimeMultipart` | `readFrom​(Class<javax.mail.internet.MimeMultipart> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​String> httpHeaders, InputStream entityStream)` | Read a type from the `InputStream`.
    `void` | `writeTo​(javax.mail.internet.MimeMultipart mimeMultipart, Class<?> type, Type genericType, Annotation[] annotations, javax.ws.rs.core.MediaType mediaType, javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders, OutputStream entityStream)` | Write a type to an HTTP message.

    - ### Methods inherited from class org.jboss.resteasy.plugins.providers.AbstractEntityProvider

      `getSize`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MimeMultipartProvider

          public MimeMultipartProvider()

  - ### Method Detail

    - #### readDataSource

          public static DataSource readDataSource​(InputStream in,
                                                  javax.ws.rs.core.MediaType mediaType)
                                           throws IOException

      Parameters:
        `in` - input stream
        `mediaType` - media type
      Returns:
        data source
      Throws:
        `IOException` - if I/O error occurred

    - #### isReadable

          public boolean isReadable​(Class<?> type,
                                    Type genericType,
                                    Annotation[] annotations,
                                    javax.ws.rs.core.MediaType mediaType)

      Ascertain if the MessageBodyReader can produce an instance of a particular type. The `type` parameter gives the class of the instance that should be produced, the `genericType` parameter gives the `java.lang.reflect.Type` of the instance that should be produced. E.g. if the instance to be produced is `List<String>`, the `type` parameter will be `java.util.List` and the `genericType` parameter will be `java.lang.reflect.ParameterizedType`.
      Parameters:
        `type` - the class of instance to be produced.
        `genericType` - the type of instance to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
        `mediaType` - the media type of the HTTP entity, if one is not specified in the request then `application/octet-stream` is used.
      Returns:
        `true` if the type is supported, otherwise `false`.

    - #### isWriteable

          public boolean isWriteable​(Class<?> type,
                                     Type genericType,
                                     Annotation[] annotations,
                                     javax.ws.rs.core.MediaType mediaType)

      Ascertain if the MessageBodyWriter supports a particular type.
      Parameters:
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written, obtained either by reflection of a resource method return type or via inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
      Returns:
        `true` if the type is supported, otherwise `false`.

    - #### readFrom

          public javax.mail.internet.MimeMultipart readFrom​(Class<javax.mail.internet.MimeMultipart> type,
                                                            Type genericType,
                                                            Annotation[] annotations,
                                                            javax.ws.rs.core.MediaType mediaType,
                                                            javax.ws.rs.core.MultivaluedMap<String,​String> httpHeaders,
                                                            InputStream entityStream)
                                                     throws IOException

      Read a type from the `InputStream`.

      In case the entity input stream is empty, the reader is expected to either return a Java representation of a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type. A `NoContentException`, if thrown by a message body reader while reading a server request entity, is automatically translated by JAX-RS server runtime into a `BadRequestException` wrapping the original `NoContentException` and rethrown for a standard processing by the registered `exception mappers`.

      Parameters:
        `type` - the type that is to be read from the entity stream.
        `genericType` - the type of instance to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - the read-only HTTP headers associated with HTTP entity.
        `entityStream` - the `InputStream` of the HTTP entity. The caller is responsible for ensuring that the input stream ends when the entity has been consumed. The implementation should not close the input stream.
      Returns:
        the type that was read from the stream. In case the entity input stream is empty, the reader is expected to either return an instance representing a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type.
      Throws:
        `IOException` - if an IO error arises. In case the entity input stream is empty and the reader is not able to produce a Java representation for a zero-length entity, `NoContentException` is expected to be thrown.

    - #### writeTo

          public void writeTo​(javax.mail.internet.MimeMultipart mimeMultipart,
                              Class<?> type,
                              Type genericType,
                              Annotation[] annotations,
                              javax.ws.rs.core.MediaType mediaType,
                              javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders,
                              OutputStream entityStream)
                       throws IOException

      Write a type to an HTTP message. The message header map is mutable but any changes must be made before writing to the output stream since the headers will be flushed prior to writing the message body.
      Parameters:
        `mimeMultipart` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - a mutable map of the HTTP message headers.
        `entityStream` - the `OutputStream` for the HTTP entity. The implementation should not close the output stream.
      Throws:
        `IOException` - if an IO error arises.

    - #### asyncWriteTo

          public CompletionStage<Void> asyncWriteTo​(javax.mail.internet.MimeMultipart mimeMultipart,
                                                    Class<?> type,
                                                    Type genericType,
                                                    Annotation[] annotations,
                                                    javax.ws.rs.core.MediaType mediaType,
                                                    javax.ws.rs.core.MultivaluedMap<String,​Object> httpHeaders,
                                                    AsyncOutputStream entityStream)

      Description copied from interface: `AsyncMessageBodyWriter`
      Write a type to an HTTP message using async IO. The message header map is mutable but any changes must be made before writing to the async output stream since the headers will be flushed prior to writing the message body.
      Parameters:
        `mimeMultipart` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - a mutable map of the HTTP message headers.
        `entityStream` - the `AsyncOutputStream` for the HTTP entity. The implementation should not close the output stream.
      Returns:
        a `CompletionStage` indicating completion